xfstests: eliminate warnings under dmapi/src/suite1/cmd (3)
[xfstests-dev.git] / 180
1 #! /bin/bash
2 # FSQA Test No. 180
3 #
4 # Test for NULL files problem
5 # test inode size is on disk after sync
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #
23 #-----------------------------------------------------------------------
24 #
25 # creator
26 owner=lachlan@sgi.com
27
28 seq=`basename $0`
29 echo "QA output created by $seq"
30
31 here=`pwd`
32 tmp=/tmp/$$
33 status=1    # failure is the default!
34 trap "_cleanup; exit \$status" 0 1 2 3 15
35
36 _cleanup()
37 {
38     _cleanup_testdir
39 }
40
41 # get standard environment, filters and checks
42 . ./common.rc
43 . ./common.filter
44
45 # real QA test starts here
46 _supported_fs xfs
47 _supported_os Linux IRIX
48
49 _setup_testdir
50 _require_scratch
51 _scratch_mkfs_xfs >/dev/null 2>&1
52 _scratch_mount
53
54 # Do we have enough space on disk?  10G
55 _require_fs_space $SCRATCH_MNT 10485760
56
57 _check_files()
58 {
59         # check file size and contents
60         i=1;
61         while [ $i -lt 1000 ]
62         do
63                 file=$SCRATCH_MNT/$i
64                 # if file is missing then sync failed
65                 if [ -e $file ]
66                 then
67                         # if file size is not 10MB then sync failed
68                         if [ `ls -l $file | tr -s ' ' | cut -d ' ' -f 5` -eq 10485760 ]
69                         then
70                                 # if file has non-zero size but no extents then it's contents will be NULLs, bad.
71                                 if xfs_bmap $file | grep 'no extents' > /dev/null
72                                 then
73                                         echo corrupt file $file - non-zero size but no extents
74                                 else
75                                         rm -f $file
76                                 fi
77                         else
78                                 echo file $file has incorrect size - sync failed
79                         fi
80                 else
81                         echo file $file missing - sync failed
82                 fi
83                 let i=$i+1
84         done
85 }
86
87 # create files and sync them
88 i=1;
89 while [ $i -lt 1000 ]
90 do
91         file=$SCRATCH_MNT/$i
92         xfs_io -f -c "pwrite -b 64k -S 0xff 0 10m" $file > /dev/null
93         if [ $? -ne 0 ]
94         then
95                 echo error creating/writing file $file
96                 exit
97         fi
98         let i=$i+1
99 done
100
101 # sync, then shutdown immediately after, then remount and test
102 sync
103 src/godown $SCRATCH_MNT
104 umount $SCRATCH_MNT
105 _scratch_mount
106 umount $SCRATCH_MNT
107 if [ ! _check_scratch_fs ]
108 then
109         echo error detected in filesystem
110         exit
111 fi
112 _scratch_mount
113 _check_files
114
115 status=0
116 exit